unit Class_CDS_Encrypt;

interface

{ -----------------------------------------------------------------------------------------------------------
  Class CDS Encrypt

  Load( filename, cds )
  Save( filename, cds )

  With a password of 1234, it will open a file, if a file does not have password it'll still open it
  but it'll save it with a password.

  Next time it's opened it'll compare the password

  Notes: For efficiency, all checking is done in memory rather than using the disk i/o, so speed is fast.

  Author: Dave Bhatia
  Date  : 1/19/99
  ----------------------------------------------------------------------------------------------------------- }


uses classes, dbclient, dialogs, sysutils;

type
  TCDSEncrypt = class(TObject)
 private
 protected
 public
   procedure Load( sCDSFile:string; oCDS:TClientDataSet );
   procedure Save( sCDSFile:string; oCDS:TClientDataSet );
end;

implementation

{ -----------------------------------------------------------------------------------------------------------

  ----------------------------------------------------------------------------------------------------------- }
procedure TCDSEncrypt.Load( sCDSFile:string; oCDS:TClientDataSet );
var
  stFromFile, stInMemory : TMemoryStream;
  iInt:integer;
  iResult:integer;
begin
  stFromFile  := TMemoryStream.Create;  // Create Stream to Load Stream from file
  stInMemory  := TMemoryStream.Create;  // In memory Stream to copy to
  try
    stFromFile.LoadFromFile( sCDSFile );  // Load the file into stream
    iInt := 0;
    stFromFile.Read( iInt, 4 ); // Extract Password , and move pointer to starting of data
    // Compare Password     // if Successful, do these
    if iInt = 1234 then
      begin
       //
       iResult := stInMemory.CopyFrom( stFromFile, stFromFile.Size-4 );  // Deduct our password size
       // Showmessage(inttostr(iResult)); // debug
       stInMemory.Position := 0;  // move to begining of file
       oCDS.LoadFromStream( stInMemory ); // Load the stream minus the password
      end
     else
      oCDS.LoadFromFile( sCDSFile );  // if password not found, then load it
  finally
    stInMemory.Free;
    stFromFile.Free;
  end; // try  
end;


{ ---------------------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------------------- }
procedure TCDSEncrypt.Save( sCDSFile:string; oCDS:TClientDataSet );
var
  stToFile, stInMemory : TMemoryStream;
  iInt:integer;
  iResult:integer;
begin
  stToFile    := TMemoryStream.Create;
  stInMemory  := TMemoryStream.Create;
  // Save Data
  try
    oCDS.SaveToStream( stInMemory );               // Save the data to stream from CDS
    iInt := 1234;
    // Set Password
    stToFile.Write( iInt, SizeOf(Integer) );       // Write Password to File
    iResult := stToFile.CopyFrom( stInMemory, 0);  // Add the rest of the data to the password
    stToFile.Position := 0;                        // move to begining of file
    stToFile.SaveToFile( sCDSFile );               // Save the password and file to disk
  finally
    stInMemory.Free;
    stToFile.Free;
  end;  
end;


end.
